/*
 * Copyright (c) 2006-2010 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution  and  use  in  source  and binary  forms,  with  or  without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 * THE SOFTWARE  IS PROVIDED "AS IS"  AND THE AUTHOR  DISCLAIMS ALL WARRANTIES
 * WITH  REGARD   TO  THIS  SOFTWARE  INCLUDING  ALL   IMPLIED  WARRANTIES  OF
 * MERCHANTABILITY AND  FITNESS.  IN NO EVENT  SHALL THE AUTHOR  BE LIABLE FOR
 * ANY  SPECIAL, DIRECT,  INDIRECT, OR  CONSEQUENTIAL DAMAGES  OR  ANY DAMAGES
 * WHATSOEVER  RESULTING FROM  LOSS OF  USE, DATA  OR PROFITS,  WHETHER  IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR  OTHER TORTIOUS ACTION, ARISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*--------------------------------------------------------------------
                         -- C N R S --
         Laboratoire d'automatique et d'analyse des systemes
            Groupe Robotique et Intelligenxce Artificielle
                   7 Avenue du colonel Roche
                     31 077 Toulouse Cedex

  Fichier              : cFunctions.h
  Fonction             : Extra Functions Definition for Trajectory Planning 
  Date de creation     : Aout 2005      
  Date de modification : Aout 2005
  Nb de lignes         : 29

  Auteur               : Ignacio HERRERA AGUILAR

----------------------------------------------------------------------*/

# ifndef CFUNCTION_H
# define CFUNCTION_H
#include "matrix.h"
#include "tpStruct.h"
#include <gb.h>

extern TP_STATUS convolution(dmat VR_A, dmat VR_B, dmat VR_C );
extern TP_STATUS deConvolution(dmat VR_A, dmat VR_B, dmat VR_D, dmat VR_R );
extern TP_STATUS SynteticDivision(dmat VR_Pol, double root, dmat VR_Quot, double *remind);
extern TP_STATUS cubicRSolution(dmat VR_Pol, dmat VR_Sol, TP_SELECT msgError);
extern TP_STATUS quarticRSolution(dmat VR_Pol, dmat VR_Sol, TP_SELECT msgError );
extern TP_STATUS quat2omega(TP_QUAT q, TP_QUAT dq, TP_VEL *omega);
extern TP_STATUS RotMat2Quat(Gb_th* Mat, TP_QUAT *Quat);
extern TP_STATUS SRSQ_Inv(dmat A, dmat InvA, dmat aux,  double lambda);
extern TP_STATUS quaternionNormalize(TP_QUAT* quat);
extern TP_STATUS calculOfQuaternionDerivative(double WxRef, double WyRef, double WzRef, const TP_QUAT* q, TP_QUAT* dq);
#endif
